<?php
// $Id: flashclient.mapclient.inc,v 1.1.2.2 2008/11/08 22:54:48 openwereld Exp $

/**
 * @file
 * Map client hook functions for flash client.
 */

/**
 * Initialize header for flash client.
 * This mapclient function is used to add javascript files or html headers. It
 * is called only once for each type of map client.
 */
function flashclient_init_header() {
  // Include javascript for the internal map client
  drupal_add_js(drupal_get_path('module', 'flashclient') .'/swfobject.js', 'module', 'header');
  
  // add css for internal map client
  //drupal_add_css(drupal_get_path('module', 'mapclient') .'/mapclient_client.css');
}

/**
 * Render body of map. Called for each map.
 * 
 * @param $attrs
 *   Reference to list of attributes in [map /] tag.
 *
 * @return
 *   HTML content to replace map tag.
 */
function flashclient_render_body(&$attrs) {
  //global $maps;
  
  // generate output
  $output = '';
  $output .= '<div id="' . $attrs['id'] . '" class="map-block ' . $attrs['class'] . '"';
  if (!empty($attrs['style'])) {
    $output .= ' style="' . $attrs['style'] . '"';
  }
  // TODO: static map? cached? suitable for teasers?
  $output .= '></div>';
  
  return $output;
}

/**
 * Finish for all maps.
 * This mapclient function is used to add javascript code in the footer.
 */
function flashclient_finish($map_count) {
  global $maps;
  
  $js = "\n//<!--\n";
  // process all maps
  foreach ($maps as $map_id => $map) {
    if ($map['mapclient'] != 'flash') {
      continue;
    }
    
    //$config_path = '../config/demis2.xml';
    //$config_path = 'http://localhost/drupal-6.x/sites/all/modules/mappingkit/flashclient/flamingo-mc/config/demis2.xml';
    //drupal_set_message('x '.var_export($map, true));
    if (isset($map['config'])) {
      $config_path = $map['config'];
    }
    else if (isset($map['nid'])) {
      $node = node_load($map['nid'], NULL);
      if ($node) {
        $config_path = mapclient_get_url('node/'. $node->nid .'/flash', TRUE);
      }
      else {
        drupal_set_message(t("Failed to load node %nid", array('%nid' => $node->nid)), 'error');
        continue;
      }
    }
    else if (isset($map['contexts'])) {
      $contexts = explode(',', $map['contexts']);
      $context = $contexts[0];
      if (preg_match('/node\/(?P<nid>\d+)(\/revisions\/(?P<vid>\d+))?/', $context, $matches)) {
        // is a mapcontext node?
        //drupal_set_message('x '.var_export($matches, true));
        $node = node_load($matches['nid'], isset($matches['vid']) ? $matches['vid'] : NULL);
        if ($node->type == 'mapcontext') {
          //drupal_set_message('layers '.var_export($node->layers, true));
          $config_path = mapclient_get_url('node/'. $node->nid .'/flash', TRUE);
        }
      }
    }
    else {
      // default?
      continue;
      //$config_path = 'http://localhost/drupal-6.x/node/4/flash';
    }
    //$config_path = urlencode($config_path);
    $swf_path = drupal_get_path('module', 'flashclient') . '/'. variable_get('flashclient_flamingo_path', DEFAULT_FLASHCLIENT_FLAMINGO_PATH);
    $js .= "var so = new SWFObject('$swf_path?config=$config_path', 'flamingo', '100%', '100%', '8', '#eaeaea');\n";
    $js .= "so.addParam('allowScriptAccess', 'always');\n";
    $js .= "so.write('{$map['id']}');\n";
  }
  $js .= "\n";
  $js .= "//-->\n";
  
  drupal_add_js($js, 'inline', 'footer');
}

