<?php
// $Id: mapclient.admin.inc,v 1.1.2.6 2008/10/24 17:39:55 openwereld Exp $

/**
 * Generate form for map client settings.
 * @return Form.
 */
function mapclient_settings_form() {
  
  $mapclients = module_invoke_all('mapclient');
  $options = array();
  foreach ($mapclients as $client => $info) {
    if ($client == DEFAULT_MAPCLIENT) {
      $info['name'] .= ' (default)';
    }
    $options[$client] = $info['name'];
  }
  //drupal_set_message(var_export($mapclients,TRUE));
  
  $form['mapclient'] = array(
    '#type' => 'fieldset'
    , '#title' => t('Map client')
    , '#collapsible' => TRUE
    );
  $form['mapclient']['mapclient'] = array(
    '#type' => 'select'
    , '#title' => t('Map client')
    , '#options' => $options
    , '#default_value' => variable_get('mapclient', DEFAULT_MAPCLIENT)
    );
  $form['mapclient']['mapclient_load_errors'] = array(
    '#type' => 'checkbox'
    , '#title' => t('Show image load errors')
    , '#default_value' => variable_get('mapclient_load_errors', DEFAULT_MAPCLIENT_LOAD_ERRORS)
    );
  $form['mapclient']['mapclient_proxy'] = array('#type' => 'textfield'
    , '#title' => t('Proxy')
    , '#description' => t('Path to proxy script. This script is used to fetch feature info, legends, etc.')
    , '#default_value' => variable_get('mapclient_proxy', DEFAULT_MAPCLIENT_PROXY)
    );
  $form['mapclient']['mapclient_baselayers_separator'] = array('#type' => 'textfield'
    , '#title' => t('Baselayers separator')
    , '#description' => t('Separator for baselayers attribute.')
    , '#default_value' => variable_get('mapclient_baselayers_separator', ',')
    );
  $form['mapclient']['mapclient_baselayer_options_separator'] = array('#type' => 'textfield'
    , '#title' => t('Baselayer options separator')
    , '#description' => t('Separator for baselayer options. Must be different from the baselayers separator!')
    , '#default_value' => variable_get('mapclient_baselayer_options_separator', '|')
    );
  $form['mapclient']['mapclient_layers_separator'] = array('#type' => 'textfield'
    , '#title' => t('Layers separator')
    , '#description' => t('Separator for layers attribute.')
    , '#default_value' => variable_get('mapclient_layers_separator', ',')
    );
  
  $form['google'] = array('#type' => 'fieldset'
    , '#title' => t('Google Maps')
    , '#collapsible' => TRUE
    , '#description' => t('Google Maps can be used as a background layer.')
    );
  $form['google']['google_maps_key'] = array('#type' => 'textfield'
    , '#title' => t('Google Maps Key')
    , '#size' => 100
    , '#default_value' => variable_get('google_maps_key', DEFAULT_GOOGLE_MAPS_KEY)
    , '#description' => t('Google Maps key for your domain. The default key is valid for localhost.')
    );
  
  $form['#validate'][] = 'mapclient_settings_form_validate';
  //$form['#submit'][] = 'mapclient_settings_form_submit';
  
  return system_settings_form($form);
}

function mapclient_settings_form_validate(&$form, &$form_state) {
  
  if ($form_values['op'] == $form_values['submit']) {
    // check that proxy file exists
    $form_values = $form_state['values'];
    $proxy = mapclient_get_url($form_values['mapclient_proxy'], TRUE);
    $response = drupal_http_request($proxy);
    
    if ($response->code != 200) {
      form_set_error('mapclient_proxy', t("Proxy %proxy doesn't exist", array('%proxy' => $proxy)));
    }
  }
}

