<?php
// $Id: mappingkit.admin.inc,v 1.1.2.6 2008/10/24 10:11:06 openwereld Exp $

function mappingkit_client_form() {
  $form = array();
  
  return $form;
}

function mappingkit_data_form() {
  $form = array();
  
  return $form;
}

function mappingkit_server_form() {
  $form = array();
  
  return $form;
}

function mappingkit_settings_form() {
  global $db_url;
  
  $help_icon = theme('advanced_help_topic', 'mappingkit', 'general-settings');
  if (!empty($help_icon)) {
    $form['help'] = array('#type' => 'markup'
      , '#value' => '<p>'. theme('advanced_help_topic', 'mappingkit', 'general-settings') . t('Click this icon for help.') .'</p>'
      , '#weight' => -1000
      );
  }
  //drupal_set_message(var_export(theme('advanced_help_topic', 'mappingkit', 'general-settings'), true));
  
  $form['tools'] = array('#type' => 'fieldset'
    , '#title' => t('Tools')
    , '#collapsible' => TRUE
    );
  
  $form['tools']['mappingkit_unzip_command'] = array('#type' => 'textfield'
    , '#title' => t('Unzip command')
    , '#default_value' => variable_get('mappingkit_unzip_command', DEFAULT_MAPPINGKIT_UNZIP_COMMAND)
    , '#size' => 100
    );
  
  $form['tools']['mappingkit_zip_command'] = array('#type' => 'textfield'
    , '#title' => t('Zip command')
    , '#default_value' => variable_get('mappingkit_zip_command', DEFAULT_MAPPINGKIT_ZIP_COMMAND)
    , '#size' => 100
    );
  
  $form['tools']['mappingkit_mapserver_url'] = array('#type' => 'textfield'
    , '#title' => t('Mapserver url')
    , '#default_value' => variable_get('mappingkit_mapserver_url', DEFAULT_MAPPINGKIT_MAPSERVER_URL)
    , '#size' => 100
    );
  $form['tools']['mappingkit_logging'] = array('#type' => 'select'
    , '#title' => t('Logging')
    , '#default_value' => variable_get('mappingkit_logging', Logger::LOG_NONE)
    , '#options' => array(Logger::LOG_NONE => 'none', Logger::LOG_DEBUG => 'debug', Logger::LOG_INFO => 'info')
    , '#description' => t('Logging can also be activated by an url parameter like &amp;log=info')
    );
  
  $form['rss'] = array('#type' => 'fieldset'
    , '#title' => t('RSS')
    , '#collapsible' => TRUE
    );
  
  $form['rss']['mappingkit_rss_enabled'] = array('#type' => 'checkbox'
    , '#title' => t('Enable RSS')
    , '#default_value' => variable_get('mappingkit_rss_enabled', 1)
    );
  
  $form['rss']['mappingkit_rss_version'] = array('#type' => 'select'
    , '#title' => t('RSS version')
    , '#options' => array('simple' => 'Simple', 'gml' => 'GML')
    , '#default_value' => variable_get('mappingkit_rss_version', 'gml')
    );
  
  $form['maps'] = array('#type' => 'fieldset'
    , '#title' => t('Maps')
    , '#collapsible' => TRUE
    , '#description' => t('Default size of maps.')
    );
  $form['maps']['mappingkit_map_width'] = array('#type' => 'textfield'
    , '#title' => t('Width')
    , '#size' => 10
    , '#default_value' => variable_get('mappingkit_map_width', DEFAULT_MAPPINGKIT_MAP_WIDTH)
    , '#prefix' => '<div class="form-inline">'
    );
  $form['maps']['mappingkit_map_height'] = array('#type' => 'textfield'
    , '#title' => t('Height')
    , '#size' => 10
    , '#default_value' => variable_get('mappingkit_map_height', DEFAULT_MAPPINGKIT_MAP_HEIGHT)
    , '#suffix' => '</div><div style="clear: both"/>'
    );
  
  $projections = mappingkit_get_projections();
  $default_value = ''; $sep = '';
  foreach ($projections as $srid => $name) {
    $default_value .= $sep . "$srid=$name";
    $sep = "\n";
  }
  $form['maps']['mappingkit_projections'] = array('#type' => 'textarea'
    , '#title' => t('Projections')
    , '#rows' => 5
    , '#default_value' => variable_get('mappingkit_projections', $default_value)
    , '#description' => t('Enter the available projections as numeric epsg <em>code=description</em>, e.g. 4326=lat/lon. Each projection on a separate line.')
    );
  /*
  $form['base'] = array('#type' => 'fieldset'
    , '#title' => t('Background layers')
    , '#collapsible' => TRUE
    );
  */
  
  $form['fonts'] = array('#type' => 'fieldset'
    , '#title' => t('Fonts')
    , '#collapsible' => TRUE
    );
  
  $form['fonts']['mappingkit_font_folders'] = array('#type' => 'textarea'
    , '#title' => t('Font folders')
    , '#rows' => 3
    , '#default_value' => variable_get('mappingkit_font_folders', DEFAULT_MAPPINGKIT_FONT_FOLDERS)
    , '#description' => t('Enter folders containing truetype fonts.')
    );
  
  $font_options = array();
  $folders = explode("\n", variable_get('mappingkit_font_folders', DEFAULT_MAPPINGKIT_FONT_FOLDERS));
  foreach ($folders as $folder) {
    if (is_dir($folder)) {
      foreach (glob($folder .'/*.ttf') as $filename) {
        $font_options[$filename] = basename($filename, '.ttf');
      }
    }
  }
  
  $form['fonts']['mappingkit_get_fonts'] = array('#type' => 'submit'
    , '#value' => t('Get fonts')
    );
  
  $form['fonts']['mappingkit_font_mono'] = array('#type' => 'select'
    , '#title' => t('Monospaced font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_mono', '')
    );
  
  $form['fonts']['mappingkit_font_sans'] = array('#type' => 'select'
    , '#title' => t('Sans serif font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_sans', '')
    );
  
  $form['fonts']['mappingkit_font_serif'] = array('#type' => 'select'
    , '#title' => t('Serif font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_serif', '')
    );
  
  $form['fonts']['mappingkit_font_italic'] = array('#type' => 'select'
    , '#title' => t('Italic font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_italic', '')
    );
  
  $form['fonts']['mappingkit_write_fonts'] = array('#type' => 'submit'
    , '#value' => t('Write font file')
    , '#description' => t('A fontset file is written to the files folder.')
    );
  
  $form['#validate'][] = 'mappingkit_settings_validate';
  
  return system_settings_form($form);
}

function mappingkit_settings_validate(&$form, &$form_state) {
  if ($form_state['values']['op'] == t('Write font file')) {
    $path = file_directory_path() .'/fontset.txt';
    
    $content = 'mono '. $form_state['values']['mappingkit_font_mono'] ."\n";
    $content .= 'sans '. $form_state['values']['mappingkit_font_sans'] ."\n";
    $content .= 'serif '. $form_state['values']['mappingkit_font_serif'] ."\n";
    $content .= 'italic '. $form_state['values']['mappingkit_font_italic'] ."\n";
    file_put_contents($path, $content);
    
    global $logger;
    $logger->debug($content);
    
    drupal_set_message(t('Font file %file has been created.', array('%file' => $path)));
  }
  
  // empty mappingkit_projections cache
  cache_clear_all('mappingkit_projections', 'cache');
}

