<?php
// $Id: openlayers.mapclient.inc,v 1.1.2.45 2008/11/16 20:51:21 openwereld Exp $

/**
 * OpenLayers release version number.
 */
define("OPENLAYERS_RELEASE", (float)variable_get('openlayers_release', DEFAULT_OPENLAYERS_RELEASE));

/**
 * Initialize header.
 */
function openlayers_init_header() {
  static $init_done = FALSE;
  
  if (!$init_done) {
    $init_done = TRUE;
    
    $path = variable_get('openlayers_path', DEFAULT_OPENLAYERS_PATH);
    $parts = parse_url($path);
    
    // check if firebug must be loaded
    if (isset($_GET['firebug'])) {
      if ($_GET['firebug'] == 'true' || $_GET['firebug'] == 'on') {
        $_SESSION['firebug'] = TRUE;
      }
      else {
        unset($_SESSION['firebug']);
      }
    }
    if (isset($_SESSION['firebug'])) {
      // debug openlayers
      if (!isset($parts['scheme'])) {
        drupal_add_js(drupal_get_path('module', 'openlayers') .'/'. dirname($path) .'/Firebug/firebug.js', 'module', 'header');
      }
      else {
        drupal_set_html_head('<script type="text/javascript" src="http://openlayers.org/dev/lib/Firebug/firebug.js"></script>');
      }
    }
    
    // Include OpenLayers.org. If the default file from the openlayers
    // website is used, the drupal_add_js function cannot by used.
    if (!isset($parts['scheme'])) {
      // relative path so drupal_add_js can be used
      //drupal_add_js(drupal_get_path('module', 'openlayers') .'/'. $path, 'module', 'header');
      //drupal_set_message($path);
      drupal_add_js($path, 'module', 'header');
      
      // todo: in this case it is possible to drupal_add_js all necessary openlayers
      // files and enable javascript caching in drupal
      $jsfiles = array(
        "OpenLayers/Util.js",
        "OpenLayers/BaseTypes.js",
        "OpenLayers/BaseTypes/Class.js",
        "OpenLayers/BaseTypes/Bounds.js",
        "OpenLayers/BaseTypes/Element.js",
        "OpenLayers/BaseTypes/LonLat.js",
        "OpenLayers/BaseTypes/Pixel.js",
        "OpenLayers/BaseTypes/Size.js",
        "OpenLayers/Console.js",
        "OpenLayers/Tween.js",
        "Rico/Corner.js",
        "Rico/Color.js",
        //"Gears/gears_init.js",
        "OpenLayers/Ajax.js",
        "OpenLayers/Request.js",
        "OpenLayers/Request/XMLHttpRequest.js",
        "OpenLayers/Events.js",
        "OpenLayers/Projection.js",
        "OpenLayers/Map.js",
        "OpenLayers/Layer.js",
        "OpenLayers/Icon.js",
        "OpenLayers/Marker.js",
        "OpenLayers/Marker/Box.js",
        "OpenLayers/Popup.js",
        "OpenLayers/Tile.js",
        "OpenLayers/Tile/Image.js",
        "OpenLayers/Tile/WFS.js",
        "OpenLayers/Layer/Image.js",
        "OpenLayers/Layer/SphericalMercator.js",
        "OpenLayers/Layer/EventPane.js",
        "OpenLayers/Layer/FixedZoomLevels.js",
        "OpenLayers/Layer/Google.js",
        "OpenLayers/Layer/VirtualEarth.js",
        "OpenLayers/Layer/Yahoo.js",
        "OpenLayers/Layer/HTTPRequest.js",
        "OpenLayers/Layer/Grid.js",
        //"OpenLayers/Layer/MapGuide.js",
        //"OpenLayers/Layer/MapServer.js",
        //"OpenLayers/Layer/MapServer/Untiled.js",
        //"OpenLayers/Layer/KaMap.js",
        //"OpenLayers/Layer/KaMapCache.js",
        //"OpenLayers/Layer/MultiMap.js",
        "OpenLayers/Layer/Markers.js",
        //"OpenLayers/Layer/Text.js",
        //"OpenLayers/Layer/WorldWind.js",
        "OpenLayers/Layer/WMS.js",
        "OpenLayers/Layer/WMS/Untiled.js",
        "OpenLayers/Layer/GeoRSS.js",
        "OpenLayers/Layer/Boxes.js",
        "OpenLayers/Layer/TMS.js",
        "OpenLayers/Layer/TileCache.js",
        "OpenLayers/Popup/Anchored.js",
        "OpenLayers/Popup/AnchoredBubble.js",
        "OpenLayers/Popup/Framed.js",
        "OpenLayers/Popup/FramedCloud.js",
        "OpenLayers/Feature.js",
        "OpenLayers/Feature/Vector.js",
        "OpenLayers/Feature/WFS.js",
        "OpenLayers/Handler.js",
        "OpenLayers/Handler/Click.js",
        "OpenLayers/Handler/Hover.js",
        "OpenLayers/Handler/Point.js",
        "OpenLayers/Handler/Path.js",
        "OpenLayers/Handler/Polygon.js",
        "OpenLayers/Handler/Feature.js",
        "OpenLayers/Handler/Drag.js",
        "OpenLayers/Handler/RegularPolygon.js",
        "OpenLayers/Handler/Box.js",
        "OpenLayers/Handler/MouseWheel.js",
        "OpenLayers/Handler/Keyboard.js",
        "OpenLayers/Control.js",
        "OpenLayers/Control/Attribution.js",
        "OpenLayers/Control/Button.js",
        "OpenLayers/Control/ZoomBox.js",
        "OpenLayers/Control/ZoomToMaxExtent.js",
        "OpenLayers/Control/DragPan.js",
        "OpenLayers/Control/Navigation.js",
        "OpenLayers/Control/MouseDefaults.js",
        "OpenLayers/Control/MousePosition.js",
        "OpenLayers/Control/OverviewMap.js",
        "OpenLayers/Control/KeyboardDefaults.js",
        "OpenLayers/Control/PanZoom.js",
        "OpenLayers/Control/PanZoomBar.js",
        "OpenLayers/Control/ArgParser.js",
        "OpenLayers/Control/Permalink.js",
        "OpenLayers/Control/Scale.js",
        "OpenLayers/Control/ScaleLine.js",
        "OpenLayers/Control/LayerSwitcher.js",
        "OpenLayers/Control/DrawFeature.js",
        "OpenLayers/Control/DragFeature.js",
        "OpenLayers/Control/ModifyFeature.js",
        "OpenLayers/Control/Panel.js",
        "OpenLayers/Control/SelectFeature.js",
        "OpenLayers/Control/NavigationHistory.js",
        "OpenLayers/Control/Measure.js",
        "OpenLayers/Geometry.js",
        "OpenLayers/Geometry/Rectangle.js",
        "OpenLayers/Geometry/Collection.js",
        "OpenLayers/Geometry/Point.js",
        "OpenLayers/Geometry/MultiPoint.js",
        "OpenLayers/Geometry/Curve.js",
        "OpenLayers/Geometry/LineString.js",
        "OpenLayers/Geometry/LinearRing.js",        
        "OpenLayers/Geometry/Polygon.js",
        "OpenLayers/Geometry/MultiLineString.js",
        "OpenLayers/Geometry/MultiPolygon.js",
        "OpenLayers/Geometry/Surface.js",
        "OpenLayers/Renderer.js",
        "OpenLayers/Renderer/Elements.js",
        "OpenLayers/Renderer/SVG.js",
        "OpenLayers/Renderer/Canvas.js",
        "OpenLayers/Renderer/VML.js",
        "OpenLayers/Layer/Vector.js",
        //"OpenLayers/Strategy.js",
        //"OpenLayers/Strategy/Fixed.js",
        //"OpenLayers/Strategy/Cluster.js",
        //"OpenLayers/Strategy/Paging.js",
        //"OpenLayers/Strategy/BBOX.js",
        //"OpenLayers/Protocol.js",
        //"OpenLayers/Protocol/HTTP.js",
        //"OpenLayers/Protocol/SQL.js",
        //"OpenLayers/Protocol/SQL/Gears.js",
        "OpenLayers/Layer/PointTrack.js",
        "OpenLayers/Layer/GML.js",
        "OpenLayers/Style.js",
        "OpenLayers/StyleMap.js",
        "OpenLayers/Rule.js",
        "OpenLayers/Filter.js",
        "OpenLayers/Filter/FeatureId.js",
        "OpenLayers/Filter/Logical.js",
        "OpenLayers/Filter/Comparison.js",
        "OpenLayers/Filter/Spatial.js",
        "OpenLayers/Format.js",
        "OpenLayers/Format/XML.js",
        "OpenLayers/Format/GML.js",
        "OpenLayers/Format/GML/Base.js",
        "OpenLayers/Format/GML/v2.js",
        "OpenLayers/Format/GML/v3.js",
        "OpenLayers/Format/KML.js",
        "OpenLayers/Format/GeoRSS.js",
        "OpenLayers/Format/WFS.js",
        "OpenLayers/Format/WKT.js",
        //"OpenLayers/Format/OSM.js",
        "OpenLayers/Format/GPX.js",
        //"OpenLayers/Format/SLD.js",
        //"OpenLayers/Format/SLD/v1.js",
        //"OpenLayers/Format/SLD/v1_0_0.js",
        //"OpenLayers/Format/SLD/v1.js",
        //"OpenLayers/Format/Filter.js",
        //"OpenLayers/Format/Filter/v1.js",
        //"OpenLayers/Format/Filter/v1_0_0.js",
        //"OpenLayers/Format/Text.js",
        "OpenLayers/Format/JSON.js",
        "OpenLayers/Format/GeoJSON.js",
        "OpenLayers/Format/WMC.js",
        "OpenLayers/Format/WMC/v1.js",
        "OpenLayers/Format/WMC/v1_0_0.js",
        "OpenLayers/Format/WMC/v1_1_0.js",
        "OpenLayers/Layer/WFS.js",
        "OpenLayers/Control/MouseToolbar.js",
        "OpenLayers/Control/NavToolbar.js",
        "OpenLayers/Control/PanPanel.js",
        "OpenLayers/Control/Pan.js",
        "OpenLayers/Control/ZoomIn.js",
        "OpenLayers/Control/ZoomOut.js",
        "OpenLayers/Control/ZoomPanel.js",
        "OpenLayers/Control/EditingToolbar.js",
        "OpenLayers/Lang.js",
        "OpenLayers/Lang/en.js"
      ); // etc.
      $base_dir = dirname($path);
      if ($base_dir == drupal_get_path('module', 'mappingkit') .'/lib/OpenLayers/lib') {
        foreach ($jsfiles as $jsfile) {
          drupal_add_js($base_dir .'/'. $jsfile, 'module', 'header');
        }
      }
    }
    else {
      // absolute path so cannot use drupal_add_js
      drupal_set_html_head('<script type="text/javascript" src="'. $path . '"></script>');
    }
    
    // add custom css
    drupal_add_css(drupal_get_path('module', 'openlayers') .'/openlayers.css');
    
    // add custom javascript code for this drupal module
    drupal_add_js(drupal_get_path('module', 'openlayers') .'/openlayers.js', 'module', 'header');
    
    // add other (extra) custom script files?
    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/MapContext.Format.js', 'extra', 'header');
    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/MapContext.Control.js', 'extra', 'header');

    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/Legend.js', 'extra', 'header');

    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/Ruler.Control.js', 'extra', 'header');

    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/PrintContext.Control.js', 'extra', 'header');

    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/FeatureInfo.Control.js', 'extra', 'header');

    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/ZoomToExtent.Control.js', 'extra', 'header');

    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/LayerSwitcher.Control.js', 'extra', 'header');
    
    // add custom javascript code
    $js = "\nwindow.\$ = window.jQuery;\n"; // prevent OpenLayers from overwriting $
    $js .= "var maps = new Array();\n"; // array of maps
    
    // set language of openlayers conform to drupal language
    global $language;
    if ($language->language != 'en') {
      // create javascript object for this language
      $js .= "OpenLayers.Lang['{$language->language}'] = {};\n";
    }
    $js .= "OpenLayers.Lang.setCode('{$language->language}');\n";
    $js .= "MappingKit.settings.OPENLAYERS_RELEASE = ". OPENLAYERS_RELEASE .";\n";
    drupal_add_js($js, 'inline', 'header');
  }
}

/**
 * Render body of map.
 */
function openlayers_render_body(&$attrs) {
  global $logger;
  
  // Remove mapclient class at this level to use it only for the map itself and
  // not for the statusbar/toolbar
  $classes = explode(' ', $attrs['class']);
  $classes = array_diff($classes, array('mapclient'));
  $attrs['class'] = implode(' ', $classes);
  
  // add openlayers class
  $attrs['class'] = (empty($attrs['class']) ? '' : $attrs['class'] . ' ') . 'openlayers';
  
  // include custom definition
  drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/MapProjection.js', 'module', 'header');
  //drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/LayerTree.js', 'module', 'header');
  
  if (isset($attrs['contexts'])) {
    // include custom definition
    if (count(explode(',', $attrs['contexts'])) > 1) {
      drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/ContextSwitcher.js', 'module', 'header');
    }
  }
  else if (isset($attrs['context'])) {
    $attrs['contexts'] = $attrs['context'];
  }
  
  if (isset($attrs['help'])) {
    // include help control
    $js_added = drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/Help.Control.js', 'extra', 'header');
  }
  
  if (isset($attrs['streetview'])) {
    // include streetview control and jquery draggable
    drupal_add_js(drupal_get_path('module', 'mappingkit') .'/lib/jquery/ui/ui.core.js', 'extra', 'header');
    drupal_add_js(drupal_get_path('module', 'mappingkit') .'/lib/jquery/ui/ui.draggable.js', 'extra', 'header');
    drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/StreetView.Control.js', 'extra', 'header');
  }
  
  if (isset($attrs['layers'])) {
    $layers = explode(',', $attrs['layers']);
    foreach ($layers as $layer_id) {
      if (isset($attrs[$layer_id])) {
        // process layer definition
        $layer = explode('|', $attrs[$layer_id]);
        
        switch ($layer[0]) {
        case 'gpx':
          if (OPENLAYERS_RELEASE <= 2.6) {
            // include custom gpx definition (it is not yet standard openlayers)
            drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/GPX.Format.js', 'extra', 'header');
            drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/GPX.Layer.js', 'module', 'header');
          }
          else {
            // override the default GPX Format in OpenLayers 2.7
            drupal_add_js(drupal_get_path('module', 'openlayers') .'/custom/OpenLayers-2.7.Format.GPX.js', 'module', 'header');
          }
          break;
        }
        //drupal_set_message('layer: '. var_export($layer, true));
      }
    }
  }
  
  $baselayer_includes = array();
  
  $logger->debug('attrs:', $attrs);
  if (isset($attrs['contexts'])) {
    $contexts = explode(',', $attrs['contexts']);
    foreach ($contexts as $context) {
      if (preg_match('/node\/(?P<nid>\d+)(\/revisions\/(?P<vid>\d+))?/', $context, $matches)) {
        // is a mapcontext node?
        $node = node_load($matches['nid'], isset($matches['vid']) ? $matches['vid'] : NULL);
        if ($node->type == 'mapcontext') {
          if (isset($node->extension['baselayers'])) {
            $baselayers = get_baselayers($node->extension['baselayers']);
            
            $logger->debug('context baselayers:', $baselayers);
            
            foreach ($baselayers as $baselayer) {
              //$variant = $baselayer['variant'];
              //$baselayer_options = $baselayer['baselayer_options'];
              switch ($baselayer['baselayer_vendor']) {
              case 'google':
                if (!isset($baselayer_includes['google'])) {
                  $google_maps_key = variable_get('google_maps_key', DEFAULT_GOOGLE_MAPS_KEY);
                  $baselayer_includes['google'] = "http://maps.google.com/maps?file=api&amp;v=2&amp;key=$google_maps_key";
                }
                break;
              case 'multimap':
                if (!isset($baselayer_includes['multimap'])) {
                  $baselayer_includes['multimap'] = 'http://clients.multimap.com/API/maps/1.1/metacarta_04';
                }
                break;
              case 've':
                if (!isset($baselayer_includes['ve'])) {
                  if (variable_get('openlayers_path', DEFAULT_OPENLAYERS_PATH) == DEFAULT_OPENLAYERS_PATH) {
                    $baselayer_includes['ve'] = 'http://dev.virtualearth.net/mapcontrol/v3/mapcontrol.js';
                  }
                  else {
                    $baselayer_includes['ve'] = 'http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.1';
                  }
                }
                break;
              case 'yahoo':
                if (!isset($baselayer_includes['yahoo'])) {
                  $baselayer_includes['yahoo'] = 'http://api.maps.yahoo.com/ajaxymap?v=3.0&appid=euzuro-openlayers';
                }
                break;
              }
            }
            /*
            // check baselayers of mapcontext
            $baselayers = $node->extension['baselayers'];
            if ($baselayers == 'google') {
              if (!$google_src_set) {
                $google_maps_key = variable_get('google_maps_key', DEFAULT_GOOGLE_MAPS_KEY);
                $src = "http://maps.google.com/maps?file=api&amp;v=2&amp;key=$google_maps_key";
                drupal_set_html_head('<script type="text/javascript" src="'. $src .'"></script>');
                $logger->debug('google included');
              }
            }
            */
          }
        }
      }
    }
  }
  
  if (isset($attrs['baselayers'])) {
    // include scripts for base layers
    $baselayers = get_baselayers($attrs['baselayers']);
    $logger->debug('baselayers', $baselayers);
    foreach ($baselayers as $baselayer) {
      $baselayer_vendor = $baselayer['baselayer_vendor'];
      //$variant = $baselayer['variant'];
      //$baselayer_options = $baselayer['baselayer_options'];
      switch ($baselayer_vendor) {
      case 'google':
        if (!isset($baselayer_includes['google'])) {
          $google_maps_key = variable_get('google_maps_key', DEFAULT_GOOGLE_MAPS_KEY);
          $baselayer_includes['google'] = "http://maps.google.com/maps?file=api&amp;v=2&amp;key=$google_maps_key";
        }
        break;
      case 'multimap':
        if (!isset($baselayer_includes['multimap'])) {
          $baselayer_includes['multimap'] = 'http://clients.multimap.com/API/maps/1.1/metacarta_04';
        }
        break;
      case 've':
        if (!isset($baselayer_includes['ve'])) {
          if (variable_get('openlayers_path', DEFAULT_OPENLAYERS_PATH) == DEFAULT_OPENLAYERS_PATH) {
            $baselayer_includes['ve'] = 'http://dev.virtualearth.net/mapcontrol/v3/mapcontrol.js';
          }
          else {
            $baselayer_includes['ve'] = 'http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.1';
          }
        }
        break;
      case 'yahoo':
        if (!isset($baselayer_includes['yahoo'])) {
          $baselayer_includes['yahoo'] = 'http://api.maps.yahoo.com/ajaxymap?v=3.0&appid=euzuro-openlayers';
        }
        break;
      case 'oam':
      case 'osm':
        // nothing to include
        break;
      }
    }
  }
  
  if (isset($attrs['streetview'])) {
    if (!isset($baselayer_includes['ve'])) {
      if (variable_get('openlayers_path', DEFAULT_OPENLAYERS_PATH) == DEFAULT_OPENLAYERS_PATH) {
        $baselayer_includes['ve'] = 'http://dev.virtualearth.net/mapcontrol/v3/mapcontrol.js';
      }
      else {
        $baselayer_includes['ve'] = 'http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.1';
      }
    }
    if (!isset($baselayer_includes['google'])) {
      $google_maps_key = variable_get('google_maps_key', DEFAULT_GOOGLE_MAPS_KEY);
      $baselayer_includes['google'] = "http://maps.google.com/maps?file=api&amp;v=2&amp;key=$google_maps_key";
    }
  }

  foreach ($baselayer_includes as $vendor => $src) {
    drupal_set_html_head('<script type="text/javascript" src="'. $src .'"></script>');
  }
  
  $output = '';
  $output .= '<div id="map-'. $attrs['id'] .'-block" class="map-block ' . $attrs['class'] . '">';

  if (!isset($attrs['controls'])) {
    $controls = array();
    if ($attrs['height'] > 200) {
      $controls[] = 'layerswitcher';
      $controls[] = 'scalebar';
      $controls[] = 'toolbar';
      $controls[] = 'statusbar';
    }
  }
  else {
    $controls = explode(',', $attrs['controls']);
    if (in_array('none', $controls)) {
      // no controls
    }
    else {
      // add controls by default?
    }
  }
  
  if (in_array('toolbar', $controls)) {
    // html for button panel
    $output .= '<div id="panels">';
    $output .= '<div id="'. $attrs['id'] .'-default-panel" class="panel"></div>';
    $output .= '<div id="'. $attrs['id'] .'-edit-panel" class="olControlEditingToolbar panel"></div>';
    $output .= '</div>';
    // clear div's
    $output .= '<div style="clear: both;"></div>';
  }

  // Html for map box (uses optional style parameter)
  $style = "width: {$attrs['width']}px; height: {$attrs['height']}px;";
  if (!empty($attrs['style'])) {
    $style .= $attrs['style'];
  }
  $output .= '<div id="'. $attrs['id'] .'" class="mapclient" style="'. $style .'"></div>';
  
  if (in_array('statusbar', $controls)) {
    // Html for status bar below map (coordinates, scale, permalink)
    $output .= '<div id="'. $attrs['id'] .'-statusbar" class="statusbar-container" style="width: '. $attrs['width'].'px;">'
               . '<div id="'. $attrs['id'] .'-statusbar-scale" class="statusbar statusbar-scale"></div>'
               . '<div class="statusbar statusbar-permalink"><a id="'. $attrs['id'] .'-statusbar-permalink">'. t('permalink') .'</a></div>'
               . '<div id="'. $attrs['id'] .'-statusbar-mouseposition" class="statusbar statusbar-mouseposition"></div>'
               . '<div id="'. $attrs['id'] .'-statusbar-projection" class="statusbar statusbar-projection"></div>'
               . '<div id="'. $attrs['id'] .'-statusbar-text" class="statusbar statusbar-text"></div>'
              .'</div>';
  }
  
  if (isset($attrs['streetview'])) {
    // embedded streetview and/or virtual earth map
    $tmp = explode(',', $attrs['streetview']);
    $params = array('width' => 400, 'height' => 300, 'views' => 've+google');
    foreach ($tmp as $param) {
      $kvp = explode('=', $param);
      $params[ $kvp[0] ] = $kvp[1];
    }
    
    $style_size = "width: {$params['width']}px; height: {$params['height']}px";
    $views_output = '';
    $tabs_output = '';
    foreach (explode('+', $params['views']) as $view) {
      switch ($view) {
      case 've':
        $views_output .= '<div id="vemap" class="streetview" style="position: relative; '. $style_size .'; display: none;"></div>';
        $tabs_output .= '<div class="embed_switcher_tab">Virtual Earth</div>';
        break;
      case 'google':
        $views_output .= '<div id="streetview" class="streetview" style="position: relative; '. $style_size .'; display: none;"></div>';
        $tabs_output .= '<div class="embed_switcher_tab">Street View</div>';
        break;
      case 'cyclomedia':
        $views_output .= '<div id="cyclomedia" class="streetview" style="position: relative; '. $style_size .'; display: none;">
          <object id="CSLite" style="'. $style_size .'" codebase="http://www.cyclomedia.nl/download/components/CycloScopeLite.cab#version=2,23,2,0" CLASSID="clsid:D83C1BD1-DCBB-11D4-9425-0050BF33FA6E">
            <param name="UseAuthorizationProxy" value="http://connector001.cycloconnect.nl"/>
            <param name="UseImageDirectoryProxy" value="http://connector001.cycloconnect.nl"/>
            <param name="UseRecordingLocationProxy" value="http://connector001.cycloconnect.nl"/>
            <param name="ChangeHorzViewdir" value="CSLite_ChangeHorzViewdir"/>
            <param name="ChangeDocumentState" value="CSLite_ChangeDocumentState"></param>
            <param name="OpenDirectionMode" value="2"/>
            <param name="OpenViewdir" value="6.18"/>
          </object>
        </div>
        <script type="text/vbscript">
        Sub CSLite_ChangeHorzViewdir(Viewdir)
          CSLiteOnChangeOrientation(Viewdir)
        End Sub
        
        Sub CSLite_ChangeDocumentState(docState, Item) 
          If docState = 128 Then
            CSLiteOnChangeLocation CSLite.CMImageDocument.ImageID, CSLite.CMImageDocument.RecordingLocation(2,0)
          End If
        End Sub
        </script>';
        $tabs_output .= '<div class="embed_switcher_tab">Cyclomedia</div>';
        break;
      }
    }
    
    $output .= '
<div id="embedded_map">
    <div id="embedded_map_main">
        <div id="embed_header">
            <div id="embed_switcher">'. $tabs_output .'</div>
            <div id="embed_closer">&nbsp;</div>
        </div>'. $views_output .'
    </div>
</div>';
  }
  
  // error messages
  $output .= '<div class="mapclient-messages" style="display: block" ><ul id="mapclient-messages"></ul></div>';
  // popups?
  $output .= '<div id="docs"></div>';
  
  $output .= '</div>'; // end of map-block
  
  // remember maps for finish function
  //$maps[ $attrs['id'] ] = $attrs;
  
  return $output;
}

/**
 * Round up to a number of significant decimals.
 */
function ceil_sig($value, $sigFigs) {
  if ($value == 0) {
    return 0;
  }

  $sign = $value > 0 ? 1 : -1;
  $value = abs($value);
  
  $exponent = floor(log10($value) + 1);
  $significand = $value / pow(10, $exponent);
  if ($sign > 0) {
    $significand = ceil($significand * pow(10, $sigFigs)) / pow(10, $sigFigs);
  }
  else {
    $significand = floor($significand * pow(10, $sigFigs)) / pow(10, $sigFigs);
  }
  $value = $significand * pow(10, $exponent);
  
  return($sign * $value);
}

/**
 * Finish for all maps.
 */
function openlayers_finish($map_count) {
  //NB: next message appears on next page
  //drupal_set_message("openlayers_finish: $map_count");
  global $maps;
  global $logger;
  
  $tilesize = variable_get('openlayers_tile_size', DEFAULT_OPENLAYERS_TILE_SIZE);
  
  $js .= "\n//<!--\n";
  $js .= "MappingKit.init = function() {\n";
  
  $js .= "OpenLayers.DOTS_PER_INCH = ". variable_get('openlayers_resolution', DEFAULT_OPENLAYERS_RESOLUTION) .";\n";
  $js .= "OpenLayers.IMAGE_RELOAD_ATTEMPTS = 1;\n"; // avoid pink tiles
  if (0 != variable_get('mapclient_load_errors', DEFAULT_MAPCLIENT_LOAD_ERRORS)) {
    $js .= "OpenLayers.Util.onImageLoadErrorColor = 'transparent';\n";
    $js .= "OpenLayers.Util.onImageLoadErrorStandard = OpenLayers.Util.onImageLoadError;\n";
    $js .= "OpenLayers.Util.onImageLoadError = function() { OpenLayers.Util.onImageLoadErrorStandard.apply(this); MappingKit.onImageLoadError.apply(this); };\n";
  }
  // A string to be used as the base for images for controls and the like. Should end with '/'
  //$js .= "OpenLayers.ImgPath = '../carto/ol/img/';
  
  // proxy host
  //$js .= "OpenLayers.ProxyHost = '" . mapclient_get_url(drupal_get_path('module', 'mappingkit') .'/proxy.php') ."?url=';\n";
  $js .= "OpenLayers.ProxyHost = '" . mapclient_get_url(variable_get('mapclient_proxy', 'proxy.php')) ."?url=';\n";
  
  $js .= "var options = {};\n";
  //{ resolutions:[1.40625,0.703125,0.3515625,0.17578125,0.087890625,0.0439453125,0.02197265625,0.010986328125,0.0054931640625,0.00274658203125,0.00137329101]};\n";
  $zoom = 1; // initial zoom
  
  // process all maps
  foreach ($maps as $map_id => $map) {
    if ($map['mapclient'] != 'openlayers') {
      continue;
    }
    
    $logger->info('map for openlayers_finish: '. var_export($map, true));
    
    $js .= "var client = {google: null, ve: null};\n";
    
    $js .= "var map_options = {};\n";
    $js .= "map_options.numZoomLevels = 20;\n";
    if ($tilesize != DEFAULT_OPENLAYERS_TILE_SIZE) {
      $js .= "map_options.tileSize = new OpenLayers.Size($tilesize, $tilesize);\n";
    }
    
    // todo: determine spherical mercator setting
    $sphericalMercator = isset($map['sphericalMercator']) ? $map['sphericalMercator'] : 'false';
    
    if (isset($map['internalprojection'])) {
      $map['maxextent'] = '-20037508.34,-20037508.34,20037508.34,20037508.34';
      $map['maxresolution'] = 2*20037508.34/256;
      $map['projection'] = 'EPSG:4326';
      $sphericalMercator = 'true';
    }
    
    if (!isset($map['projection'])) {
      $map['projection'] = 'EPSG:4326';
    }
    
    $numdigits = 5;
    if (isset($map['internalprojection'])) {
      $js .= "map_options.projection = new OpenLayers.Projection('EPSG:900913');\n";
      $js .= "map_options.displayProjection = new OpenLayers.Projection('EPSG:4326');\n";
      $js .= "map_options.units = 'm';\n";
      $js .= "map_options.maxExtent = new OpenLayers.Bounds({$map['maxextent']});\n";
    }
    else {
      $js .= "map_options.projection = new OpenLayers.Projection('{$map['projection']}');\n";
      if ($map['projection'] == 'EPSG:4326') {
        $js .= "map_options.units = 'degrees';\n";
      }
      else {
        $js .= "map_options.units = 'm';\n";
        $numdigits = 0;
      }
    }
    /*
    $numdigits = 0;
    if (isset($map['projection'])) {
      switch ($map['projection']) {
      case 'EPSG:900913':
        $sphericalMercator = 'true';
        $js .= "map_options.projection = new OpenLayers.Projection('EPSG:900913');\n";
        $js .= "map_options.displayProjection = new OpenLayers.Projection('EPSG:4326');\n";
        //$js .= "map_options.maxExtent = new OpenLayers.Bounds(-10018754, -10018754, 10018754, 10018754);\n";
        $map['maxextent'] = '-20037508.34, -20037508.34, 20037508.34, 20037508.34';
        $map['maxresolution'] = 2*20037508.34/256;
        $js .= "map_options.maxExtent = new OpenLayers.Bounds(-20037508.34, -20037508.34, 20037508.34, 20037508.34);\n";
        $js .= "map_options.units = 'm';\n";
        $numdigits = 5;
        break;
      case 'EPSG:4326':
        $js .= "map_options.units = 'degrees';\n";
        $numdigits = 5;
        break;
      default:
        $js .= "map_options.units = 'm';\n";
        break;
      }
    }
    */
    
    if (isset($map['restrictedextent'])) {
      $map['maxextent'] = $map['restrictedextent'];
    }
    elseif (isset($map['extent'])) {
      $initial_extent = $map['extent'];
      
      if (!isset($map['maxextent'])) {
        // use extent for maxextent
        $map['maxextent'] = $map['extent'];
      }
    }
    
    if (isset($map['maxresolution'])) {
      $maxResolution = $map['maxresolution'];
    }
    else {
      $maxResolution = NULL;
    }
    
    if (isset($map['restrictedextent'])) {
      $restrictedextent = explode(',', $map['restrictedextent']);
      
      // NOTE: next line is required for OL 2.6, but not later
      $initial_extent = $map['restrictedextent'];
      //drupal_set_message("restricted extent is $initial_extent", 'error');
      
      if (!$maxResolution) {
        $maxResolution = max(($restrictedextent[2] - $restrictedextent[0])/$map['width']
          , ($restrictedextent[3] - $restrictedextent[1])/$map['height']);
        
        // for baselayers in EPSG:4326
        $maxResolution = 1.40625;
        //$js .= "map_options.maxExtent = new OpenLayers.Bounds({$map['restrictedextent']});\n";
        //$js .= "map_options.maxExtent = new OpenLayers.Bounds(-180,-90,180,90);\n";
      }

      $js .= "var extent = new OpenLayers.Bounds({$map['restrictedextent']});\n";
      $js .= "if (map_options.displayProjection) { extent.transform(map_options.displayProjection, map_options.projection); }\n";
      $js .= "map_options.restrictedExtent = extent;\n";
      //$js .= "map_options.maxExtent = extent;\n";
    }
    elseif (isset($map['maxextent'])) {
      $maxextent = explode(',', $map['maxextent']);
      if (!$maxResolution) {
        $maxResolution = max(($maxextent[2] - $maxextent[0])/$map['width']
          , ($maxextent[3] - $maxextent[1])/$map['height']);
      }
      
      $js .= "map_options.maxExtent = new OpenLayers.Bounds({$map['maxextent']});\n";
    }
    else {
      if (!$maxResolution) {
        $maxResolution = max(360/$map['width'], 180/$map['height']);
      }
      
      $js .= "map_options.maxExtent = new OpenLayers.Bounds(-180, -90, 180, 90);\n";
    }
    $js .= "map_options.maxResolution = $maxResolution;\n";
    
    /*
    if (isset($map['projection'])) {
      $js .= "map_options.projection = new OpenLayers.Projection('{$map['projection']}');\n";
    }
    */
    
    if (isset($map['title'])) {
      $js .= "map_options.title = '{$map['title']}';\n";
    }
    
    $zoom = isset($map['zoom']) ? $map['zoom'] : 5;
    $center = isset($map['center']) ? explode(',', $map['center']) : array(0, 0);
    
    if (!isset($map['controls'])) {
      // default controls
      $controls = array();
      if ($map['height'] > 200) {
        $controls[] = 'layerswitcher';
        $controls[] = 'scalebar';
        $controls[] = 'toolbar';
        $controls[] = 'statusbar';
      }
    }
    else {
      $controls = explode(',', (isset($map['controls']) ? $map['controls'] : ''));
    }
    if (in_array('none', $controls)) {
      $js .= "map_options.controls = [];\n";
    }
    
    // (1) create map object
    $_SESSION['firebug'] && $js .= "OpenLayers.Console.debug('map_options', map_options);\n";
    $js .= "var map = new OpenLayers.Map('". $map['id'] ."', map_options);\n";
    $js .= "client.map = map;\n";
    $js .= "client.baselayers = [];\n";
    $js .= "maps[maps.length] = map;\n";
    
    // add legend here to have new layers show their legendurl
    $js .= "var legend = new MappingKit.Legend(map, 'legend', {title: Drupal.t('Legend')});\n";
    
    // (2) add the baselayers
    if (isset($map['baselayers'])) {
      $baselayers = get_baselayers($map['baselayers']);
      foreach ($baselayers as $baselayer) {
        $baselayer_vendor = $baselayer['baselayer_vendor'];
        $variant = $baselayer['variant'];
        $baselayer_options = $baselayer['baselayer_options'];
        switch ($baselayer_vendor) {
        case 'google':
          // 20 zoom levels works fine
          // alternatives: Streets=(), Satellite=G_SATELLITE_MAP, Hybrid=G_HYBRID_MAP
          $variants = array('default' => 'G_HYBRID_MAP', 'streets' => 'G_NORMAL_MAP', 'satellite' => 'G_SATELLITE_MAP', 'hybrid' => 'G_HYBRID_MAP', 'physical' => 'G_PHYSICAL_MAP');
          $type = isset($variants[$variant]) ? $variants[$variant] : $variants['default'];
          $js .= "if (typeof $type != 'undefined') {\n";
          $js .= get_baselayer_options_js($baselayer_options);
          $js .= "layer_options.type = {$type};\n";
          $js .= "layer_options.sphericalMercator = {$sphericalMercator};\n";
          $js .= "client.google = new OpenLayers.Layer.Google('Google - $variant', layer_options);\n";
          $js .= "client.baselayers[client.baselayers.length] = client.google;\n";
          $js .= "}\n";
          break;
        case 've':
          // Roads=VEMapStyle.Road, Aerial=VEMapStyle.Aerial, VEMapStyle.Hybrid
          $variants = array('default' => 'Hybrid', 'streets' => 'Road', 'satellite' => 'Aerial', 'hybrid' => 'Hybrid');
          $type = isset($variants[$variant]) ? $variants[$variant] : $variants['default'];
          $js .= "if (typeof VEMapStyle != 'undefined') {\n";
          $js .= get_baselayer_options_js($baselayer_options);
          $js .= "layer_options.type = VEMapStyle.$type;\n";
          $js .= "layer_options.sphericalMercator = {$sphericalMercator};\n";
          $js .= "client.ve = new OpenLayers.Layer.VirtualEarth('Virtual Earth - $variant', layer_options);\n";
          $js .= "client.baselayers[client.baselayers.length] = client.ve;\n";
          $js .= "}\n";
          break;
        case 'yahoo':
          // (), YAHOO_MAP_SAT, YAHOO_MAP_HYB
          $variants = array('default' => 'YAHOO_MAP_HYB', 'satellite' => 'YAHOO_MAP_SAT', 'hybrid' => 'YAHOO_MAP_HYB');
          $type = isset($variants[$variant]) ? $variants[$variant] : $variants['default'];
          $js .= "if (typeof $type != 'undefined') {\n";
          $js .= get_baselayer_options_js($baselayer_options);
          $js .= "layer_options.type = {$type};\n";
          $js .= "layer_options.sphericalMercator = {$sphericalMercator};\n";
          $js .= "client.yahoo = new OpenLayers.Layer.Yahoo('Yahoo - $variant', layer_options);\n";
          $js .= "client.baselayers[client.baselayers.length] = client.yahoo;\n";
          $js .= "}\n";
          break;
        case 'oam':
          $js .= get_baselayer_options_js();
          $js .= "layer_options.type = 'png';\n";
          $js .= "layer_options.getURL = osm_getTileURL;\n";
          $js .= "layer_options.displayOutsideMaxExtent = true;\n";
          $js .= "layer_options.attribution = 'OpenAerialMap';\n";
          //$js .= "client.osm = new OpenLayers.Layer.TMS('OpenStreetMap - Tiles@Home', 'http://tah.openstreetmap.org/Tiles/tile.php/', layer_options);\n";
          $js .= "client.oam = new OpenLayers.Layer.TMS('OpenAerialMap', 'http://tile.openaerialmap.org/tiles/1.0.0/openaerialmap-900913/', layer_options);\n";
          $js .= "client.baselayers[client.baselayers.length] = client.oam;\n";
          break;
        case 'osm':
          $js .= get_baselayer_options_js();
          $js .= "layer_options.type = 'png';\n";
          $js .= "layer_options.getURL = osm_getTileURL;\n";
          $js .= "layer_options.displayOutsideMaxExtent = true;\n";
          $js .= "layer_options.attribution = 'OpenStreetMap';\n";
          //$js .= "client.osm = new OpenLayers.Layer.TMS('OpenStreetMap - Tiles@Home', 'http://tah.openstreetmap.org/Tiles/tile.php/', layer_options);\n";
          $js .= "client.osm = new OpenLayers.Layer.TMS('OpenStreetMap', 'http://tile.openstreetmap.org/', layer_options);\n";
          $js .= "client.baselayers[client.baselayers.length] = client.osm;\n";
          break;
        case 'none':
          //$js .= "map.addLayer(new OpenLayers.Layer.Image('None', 'white.png', map.maxExtent, new OpenLayers.Size(1, 1)));\n";
          $js .= "client.none = new OpenLayers.Layer(Drupal.t('None'), {isBaseLayer: true});\n";
          $js .= "client.baselayers[client.baselayers.length] = client.none;\n";
          break;
        }
      }
      /* */
      $js .= "if (\$defined(client.google) && \$defined(client.ve)) {\n";
      // give virtual earth same resolutions/max_zoom_level as google
      $js .= "  client.ve.RESOLUTIONS = client.google.RESOLUTIONS;\n";
      $js .= "  client.ve.MAX_ZOOM_LEVEL = client.google.MAX_ZOOM_LEVEL;\n";
      $js .= "}\n";
      /* */
      // now add all baselayers
      $js .= "for (var i = 0; i < client.baselayers.length; i++) {\n";
      $js .= "  map.addLayer(client.baselayers[i]);\n";
      $js .= "}\n";
    }
    
    // (3) contexts
    if (isset($map['contexts'])) {
      $contexts = explode(',', $map['contexts']);
      foreach ($contexts as $context) {
        // add context to map
        
        if (preg_match('/node\/(?P<nid>\d+)(\/revisions\/(?P<vid>\d+))?/', $context, $matches)) {
          // is a mapcontext node?
          $node = node_load($matches['nid'], isset($matches['vid']) ? $matches['vid'] : NULL);
          if ($node->type == 'mapcontext') {
            $context = "node/{$node->nid}/context";
            $url = mapclient_get_url($context);
            
            if (is_numeric($node->dminx)) {
              $initial_extent = $node->dminx .','. $node->dminy .','. $node->dmaxx .','. $node->dmaxy;
            }
          }
          else {
            drupal_set_message(t('Node is not a map context'), 'error');
            continue;
          }
        }
        else {
          $url = mapclient_get_url($context);
        }
        
        $js .= "var wmc_options = {};\n";
        $js .= "wmc_options.layerOptions = {isBaseLayer: false, buffer: 0, displayInLegend: true};\n";
        $js .= "var wmc = new OpenLayers.Format.MapContext(wmc_options);\n";
        $js .= "var url = '". $url ."';\n";
        
        // create map from context by synchronous load
        $js .= "var request = new OpenLayers.Ajax.Request(url, {method: 'get', asynchronous: false, parameters: {q: '$context'} });\n";
        $js .= "var text = '';\n";
        $js .= "if (request && request.transport) {\n";
        $js .= "  text = request.transport.responseText;\n";
        $js .= "}\n";
        
        $js .= "var tmp = map.getNumLayers() == 1 && map.layers[0].CLASS_NAME == 'OpenLayers.Layer';\n";

        // merge layers from context
        $js .= "wmc.read(text, {'map': client.map});\n";
        
        // set baselayer to one in context
        $js .= "if (tmp && wmc.context.layers.length > 0 && wmc.context.layers[0].isBaseLayer) { map.setBaseLayer(map.layers[1]); }\n";
        
        $_SESSION['firebug'] && $js .= "OpenLayers.Console.debug('wmc', wmc);\n";
        /*
        $js .= "if (!map.getCenter()) {\n";
        $js .= "  map.setCenter(wmc.context.bounds.getCenterLonLat());\n";
        $js .= "}\n";
        */
      }
      // make sure we have a baseLayer in case the default openlayers 
      // distribution is used without wmc patches
      $js .= "if (map.layers.length > 0 && !map.layers[0].isBaseLayer) { map.layers[0].setOpacity(0.5); map.setBaseLayer(map.layers[0]); }\n";
    }
    
    // (4) layers
    $layer_count_wms = 0;
    if (isset($map['layers'])) {
      $layers = explode(',', $map['layers']);
      foreach ($layers as $layer_id) {
        if (isset($map[$layer_id])) {
          $layer = explode('|', $map[$layer_id]);
          
          $js .= "var layer_options = {};\n";
          if ($sphericalMercator == 'true') {
            $js .= "layer_options.projection = new OpenLayers.Projection('EPSG:4326');\n";
          }
          
          switch ($layer[0]) {
          case 'feed': // feed|url
            $url = mapclient_get_url($layer[1]);
            $js .= "MappingKit.feedMap($url, {$map['id']});\n";
            break;
            
          case 'georss': // georss|url|title|marker
            if ($maxResolution) {
              $js .= "layer_options.maxResolution = $maxResolution;\n";
            }
            $title = t('GeoRSS');
            $url = mapclient_get_url($layer[1]);
            if (isset($layer[2]) && $layer[2] != '') {
              $title = $layer[2];
              // title is include in layer specs; do NOT use title from rss feed
              $js .= "layer_options.useFeedTitle = false;\n";
            }
            if (isset($layer[3]) && $layer[3] != '') {
              // icon is included in layer specs
              $icon_url = mapclient_get_url($layer[3]);
              $js .= "layer_options.icon = new OpenLayers.Icon('{$icon_url}');\n";
            }
            
            $title = js_ize($title); // check title for '
            $js .= "var georss = new OpenLayers.Layer.GeoRSS('{$title}', '{$url}', layer_options);\n";
            $js .= "map.addLayer(georss);\n";
            break;
            
          case 'gml': // gml|url|title
            $url = mapclient_get_url($layer[1]);
            $title = js_ize(isset($layer[2]) && $layer[2] != '' ? $layer[2] : 'GML');
            
            $js .= "map.addLayer(new OpenLayers.Layer.GML('{$title}', '{$url}', layer_options));\n";
            break;
            
          case 'gpx': // gpx|url|title|marker|options
            $title = t('GPX');
            $url = mapclient_get_url($layer[1]);
            if (OPENLAYERS_RELEASE >= 2.7) {
              // OpenLayers release >= 2.7
              $js .= "layer_options.format = OpenLayers.Format.GPX;\n";
              // todo: layer_options.projection = map.displayProjection;\n?
              if (isset($layer[2]) && $layer[2] != '') {
                $title = $layer[2];
                // title is include in layer specs; do NOT use title from rss feed
                $js .= "layer_options.useFeedTitle = false;\n";
              }
              $js .= "layer_options.formatOptions = { extractAttributes: true };\n";
              $js .= "layer_options.formatOptions.waypointStyle = OpenLayers.Util.extend({}, OpenLayers.Feature.Vector.style['default']);\n";
              if (isset($layer[3]) && $layer[3] != '') {
                // icon is included in layer specs
                $icon_url = mapclient_get_url($layer[3]);
                
                $js .= "layer_options.formatOptions.waypointStyle.externalGraphic = '$icon_url';\n";
                $js .= "layer_options.formatOptions.waypointStyle.graphicWidth = 16;\n";
                $js .= "layer_options.formatOptions.waypointStyle.graphicHeight = 16;\n";
                $js .= "layer_options.formatOptions.waypointStyle.graphicOpacity = 1;\n";
              }
              else {
                // todo: default icon?
              }
              if (isset($layer[4])) {
                $extras = mk_explode_options($layer[4]);
                //drupal_set_message('extras:'.var_export($extras,true));
                $js .= mk_add_properties_js('layer_options', $extras);
              }
              
              $title = js_ize($title); // check title for '
              $js .= "var gpx = new OpenLayers.Layer.GML('{$title}', '{$url}', layer_options);\n";
              //$js .= "gpx.events.register('loadend', gpx, MappingKit.onLoadEndGPX);\n";
              $js .= "map.addLayer(gpx);\n";
              
              // todo: make waypoints show popups
              $js .= "var selectControl = new OpenLayers.Control.SelectFeature(gpx, {onSelect: MappingKit.onFeatureSelect, onUnselect: MappingKit.onFeatureUnselect, hover: false, geometryTypes: ['OpenLayers.Geometry.Point']});\n";
              $js .= "map.addControl(selectControl);\n";
              $js .= "selectControl.activate();\n";
              $js .= "MappingKit.selectControls[MappingKit.selectControls.length] = selectControl;\n";
            }
            else {
              // OpenLayers release <= 2.6
              if ($maxResolution) {
                //$js .= "layer_options.maxResolution = $maxResolution;\n";
              }
              // assume EPSG:4326 for GPX layer
              //$js .= "layer_options.projection = 'EPSG:4326';\n";
              if (isset($layer[2]) && $layer[2] != '') {
                $title = $layer[2];
                // title is include in layer specs; do NOT use title from rss feed
                $js .= "layer_options.useFeedTitle = false;\n";
              }
              if (isset($layer[3]) && $layer[3] != '') {
                // icon is included in layer specs
                $icon_url = mapclient_get_url($layer[3]);
                $js .= "layer_options.icon = new OpenLayers.Icon('{$icon_url}');\n";
              }
              if (isset($layer[4])) {
                $extras = mk_explode_options($layer[4]);
                //drupal_set_message('extras:'.var_export($extras,true));
                $js .= mk_add_properties_js('layer_options', $extras);
              }
              
              $title = js_ize($title); // check title for '
              $js .= "var gpx = new MappingKit.Layer.GPX('{$title}', '{$url}', layer_options);\n";
              $js .= "map.addLayer(gpx);\n";
            }
            break;
            
          case 'image': // image|url|title|size
            $title = t('Image');
            $url = mapclient_get_url($layer[1]);
            if (isset($layer[2]) && $layer[2] != '') {
              $title = $layer[2];
            }
            $title = js_ize($title); // check title for '
            $js .= "var image = new OpenLayers.Layer.Image('{$title}', '{$url}', map_options.maxExtent, new OpenLayers.Size({$layer[3]}), layer_options);\n";
            $js .= "map.addLayer(image);\n";
            break;
            
          case 'kml': // kml|url|title|options
            $title = t('KML');
            $url = mapclient_get_url($layer[1]);
            // title
            if (isset($layer[2]) && $layer[2] != '') {
              $title = $layer[2];
            }
            // options
            $hover = 'false';
            if (isset($layer[3]) && $layer[3] != '') {
              $extras = mk_explode_options($layer[3]);
              
              $js .= "layer_options.formatOptions = {};\n";
              foreach ($extras as $key => $value) {
                switch ($key) {
                case 'extractStyles':
                case 'extractAttributes':
                  $js .= "layer_options.formatOptions.$key = $value;\n";
                  break;
                case 'hover':
                  $hover = $value;
                  break;
                default:
                  $js .= mk_add_properties_js('layer_options', $key, $value);
                  break;
                }
              }
            }
            else {
              // defaults
              $js .= "layer_options.formatOptions = { extractStyles: true, extractAttributes: true }\n;";
            }
            $js .= "layer_options.format = OpenLayers.Format.KML;\n";
            $js .= "var kml = new OpenLayers.Layer.GML('$title', '$url', layer_options);\n";
            $js .= "map.addLayer(kml);\n";
            
            $js .= "var selectControl = new OpenLayers.Control.SelectFeature(kml, {onSelect: MappingKit.onFeatureSelect, onUnselect: MappingKit.onFeatureUnselect, hover: $hover});\n";
            $js .= "map.addControl(selectControl);\n";
            $js .= "selectControl.activate();\n";
            $js .= "MappingKit.selectControls[MappingKit.selectControls.length] = selectControl;\n";
            break;
            
          case 'wms': // wms|url|title|names|options
            $layer_count_wms++;
            $title = js_ize(isset($layer[2]) && $layer[2] != '' ? $layer[2] : 'WMS');
            $js .= "layer_options.opacity = 1.0;\n";
            $js .= "layer_options.displayInLegend = true;\n";
            if (isset($layer[4])) {
              $extras = mk_explode_options($layer[4]);
              foreach ($extras as $key => $value) {
                switch ($key) {
                case 'legendurl':
                  $js .= "layer_options.legend = {};\n";
                  $js .= "layer_options.legend.href = '{$value}';\n";
                  break;
                case 'info_format':
                  $js .= "layer_options.info_formats = ['{$value}'];\n";
                  break;
                default:
                  $js .= mk_add_properties_js('layer_options', $key, $value);
                  break;
                }
              }
            }
            
            $js .= "var wms_options = {layers: '{$layer[3]}', format: 'image/png', transparent: 'TRUE'};\n";
            // try to pass additional wms request options
            //$parts = parse_url($layer[1], PHP_URL_QUERY);
            //drupal_set_message(var_export($parts,true));
            
            $js .= "layer_options.isBaseLayer = !\$defined(map.baseLayer);\n";
            $js .= "var wms = new OpenLayers.Layer.WMS('{$title}', '{$layer[1]}', wms_options, layer_options);\n";
            // gutter for demis world maps: 18
            $js .= "wms.gutter = 0;\n";
            $js .= "map.addLayer(wms);\n";
            break;
            
          case 'wfs': // wfs|service|title|typename|options
            $title = js_ize(isset($layer[2]) && $layer[2] != '' ? $layer[2] : 'WFS');
            $js .= "var wfs_params = {typename: '{$layer[3]}', maxfeatures: 100};\n";
            $js .= "var wfs_options = {};\n";
            $js .= "if (map.displayProjection) { wfs_options.projection = map.displayProjection; }\n;";
            if (isset($layer[4])) {
              $extras = mk_explode_options($layer[4]);
              foreach ($extras as $key => $value) {
                switch ($key) {
                case 'maxfeatures':
                  $js .= "wfs_params.maxfeatures = $value;\n";
                  break;
                  
                case 'extract':
                  $js .= "wfs_options.extractAttributes = $value;\n";
                  break;
                  
                case 'styleMap':
                  $js .= "var styleMap_options = {};\n";
                  $js .= mk_add_properties_js('styleMap_options', $value);
                  $js .= "wfs_options.styleMap = new OpenLayers.StyleMap(styleMap_options);\n";
                  break;
                  
                case 'style':
                  $js .= "wfs_options.style = OpenLayers.Util.extend({}, OpenLayers.Feature.Vector.style['default']);\n";
                  $js .= mk_add_properties_js('wfs_options.style', $value);
                  break;
                  
                default:
                  $js .= mk_add_properties_js('wfs_options', $key, $value);
                  break;
                }
              }
            }
            // todo: extractFeatures: false/true?
            // old style feature class? featureClass: OpenLayers.Feature.WFS
            $js .= "var wfs = new OpenLayers.Layer.WFS('{$title}', '{$layer[1]}', wfs_params, wfs_options);\n";
            $js .= "map.addLayer(wfs);\n";
            
            // hover control
            // todo: what with > 1 wfs layer??
            //$js .= "var selectControl = new OpenLayers.Control.SelectFeature(wfs, {onSelect: MappingKit.wfsFeaturePopup, onUnselect: MappingKit.wfsFeatureUnPop, hover: false});\n";
            $js .= "var selectControl = new OpenLayers.Control.SelectFeature(wfs, {onSelect: MappingKit.onFeatureSelect, onUnselect: MappingKit.onFeatureUnselect, hover: false});\n";
            $js .= "map.addControl(selectControl);\n";
            $js .= "selectControl.activate();\n";
            $js .= "MappingKit.selectControls[MappingKit.selectControls.length] = selectControl;\n";
            break;
            
          default:
            $function = 'openlayers_finish_layer_' . $layer[0];
            if (function_exists($function)) {
              $js .= $function($layer);
            }
            else {
              drupal_set_message(t('Unknown layer type %type', array('%type' => $layer[0])), 'error');
            }
            break;
          }
        }
      }
    }
    
    // (5) controls
    if (in_array('layerswitcher', $controls)) {
      // add layer switcher
      $js .= "map.addControl(new MappingKit.Control.LayerSwitcher({title: Drupal.t('Layer switcher')}));\n";
    }
    if (in_array('scalebar', $controls)) {
      // scale line
      $js .= "map.addControl(new OpenLayers.Control.ScaleLine());\n";
    }

    if (in_array('toolbar', $controls)) {
      // panel container with panels
      $js .= "var default_container = document.getElementById('{$map['id']}-default-panel');\n";
      $js .= "var default_panel = new OpenLayers.Control.Panel({div: default_container});\n";
      // (5a) default panel (navigationhistory, zoomtomaxextent)
      $js .= "if (OpenLayers.Control.NavigationHistory) {\n";
        // history navigation (not available in OpenLayers 2.5)
        $js .= "nav = new OpenLayers.Control.NavigationHistory();\n";
        $js .= "map.addControl(nav);\n";
        $js .= "nav.next.title = Drupal.t('Next extent');\n";
        $js .= "nav.previous.title = Drupal.t('Previous extent');\n";
        
        //$js .= "try {\n"; // for IE?
        $js .= "default_panel.addControls([nav.previous, nav.next]);\n";
        $js .= "map.addControl(default_panel);\n";
        //$js .= "} catch (e) { alert(e.message); }\n";
      $js .= "}\n";
      if ($initial_extent) {
        // control to zoom to initial extent
        $js .= "var initialextent = new OpenLayers.Bounds($initial_extent);\n";
        $js .= "if (map_options.displayProjection) { initialextent.transform(map_options.displayProjection, map_options.projection); }\n";
        $js .= "default_panel.addControls([new OpenLayers.Control.ZoomToExtent({title: Drupal.t('Zoom to the initial extent'), extent: initialextent})]);\n";
      }
      else {
        // control to zoom to max extent
        $js .= "default_panel.addControls([new OpenLayers.Control.ZoomToMaxExtent({title: Drupal.t('Zoom to the maximum extent')})]);\n";
      }
      // ruler control
      $js .= "default_panel.addControls([new OpenLayers.Control.Ruler({title: Drupal.t('Measure distances'), 'div': '{$map['id']}-statusbar-text'})]);\n";
      // feature info
      $js .= "try {\n"; // for IE?
        $js .= "var control = new MappingKit.Control.FeatureInfo({title: Drupal.t('Feature info')});\n";
        $js .= "default_panel.addControls([control]);\n";
      $js .= "} catch (e) { alert(e.message); }\n";
      
      // control to show map context
      $js .= "var control = new MappingKit.Control.MapContext({title: Drupal.t('Get current map context')});\n";
      $js .= "default_panel.addControls([control]);\n";
      
      // only wms layers can be printed
      if (module_exists('map2pdf') && user_access('print map to pdf') 
        //&& (isset($map['contexts']) || $layer_count_wms > 0)
        ) {
        $js .= "var control = new MappingKit.Control.PrintContext({title: Drupal.t('Print current map')});\n";
        $js .= "default_panel.addControls([control]);\n";
      }
      // view switcher
      if (isset($map['streetview'])) {
        $js .= "MappingKit.streetview = new MappingKit.Control.StreetView('embedded_map_main', {isDraggable: true, title: Drupal.t('Toggle street view popup')});\n";
        $js .= "default_panel.addControls([MappingKit.streetview]);\n";
      }
      // help control
      if (isset($map['help'])) {
        $js .= "var control = new MappingKit.Control.Help({title: Drupal.t('Help'), 'url': '".mapclient_get_url($map['help'])."'});\n";
        $js .= "default_panel.addControls([control]);\n";
      }
    }
    
    // (5b) other panels
    if (in_array('edit', $controls)) {
      // editing vector layer
      $title = t('Drawing layer');
      $js .= "var vlayer = new OpenLayers.Layer.Vector('$title', options);\n";
      $js .= "map.addLayer(vlayer);\n";
      // editing toolbar
      $js .= "var container = document.getElementById('{$map['id']}-edit-panel');\n";
      $js .= "var edit_panel = new OpenLayers.Control.EditingToolbar(\n";
      $js .= "    vlayer, {div: container}\n";
      $js .= ");\n";
      $js .= "edit_panel.controls[0].panel_div.title = Drupal.t('Pan');\n";
      $js .= "edit_panel.controls[1].panel_div.title = Drupal.t('Add point feature');\n";
      $js .= "edit_panel.controls[2].panel_div.title = Drupal.t('Add line feature');\n";
      $js .= "edit_panel.controls[3].panel_div.title = Drupal.t('Add polygon feature');\n";
      // modify feature with RESHAPE|DRAG (and not ROTATE|RESIZE)
      $js .= "var modifyOptions = {title: Drupal.t('Modify feature'), mode: OpenLayers.Control.ModifyFeature.RESHAPE | OpenLayers.Control.ModifyFeature.DRAG};\n";
      $js .= "modifyOptions.onDelete = function(feature) { alert('delete ' + feature.id); };\n";
      $js .= "modifyOptions.onModification = MappingKit.OpenLayers.onFeatureModification;\n";
      $js .= "edit_panel.addControls(new OpenLayers.Control.ModifyFeature(vlayer, modifyOptions));\n";
      // add edit_panel to map
      $js .= "map.addControl(edit_panel);\n";
    }
    
    if (in_array('statusbar', $controls)) {
      // (5c) controls in status bar
      // scale
      //$js .= "var elem = document.getElementById('{$map['id']}-statusbar-scale');\n";
      $js .= "map.addControl(new OpenLayers.Control.Scale('{$map['id']}-statusbar-scale'));\n";
      //$js .= "elem.className = 'statusbar statusbar-scale';\n";
      // cursor coordinates
      $js .= "var elem = document.getElementById('{$map['id']}-statusbar-mouseposition');\n";
      $js .= "map.addControl(new OpenLayers.Control.MousePosition({div: elem, numdigits: $numdigits}));\n";
      $js .= "elem.className = 'statusbar statusbar-mouseposition';\n";
      // map projection
      $js .= "var elem = document.getElementById('{$map['id']}-statusbar-projection');\n";
      $js .= "map.addControl(new OpenLayers.Control.MapProjection({div: elem}));\n";
      // permalink
      $js .= "map.addControl(new OpenLayers.Control.Permalink('{$map['id']}-statusbar-permalink'));\n";
    }
    
    if (isset($map['overview'])) {
      // See http://trac.openlayers.org/wiki/Control/OverviewMap
      // overview=list_of_overview_layers|? + overview_layers specs
      // Separate overview map block
      
      $parts = explode('|', $map['overview']);
      if (count($parts) >= 1) {
        $layers = explode(',', $parts[0]);
        foreach ($layers as $id) {
          if (isset($map[$id])) {
            
            // Add layer to overview.layers
            $layer = explode('|', $map[$id]);
            switch ($layer[0]) {
            default:
              $function = 'openlayers_finish_layer_' . $layer[0];
              if (function_exists($function)) {
                $js .= $function($layer, NULL);
              }
              else {
                drupal_set_message(t('Unknown layer type %type', array('%type' => $layer[0])), 'error');
              }
              break;
            }
          }
        }
      }
      
      $js .= "var overview_options = { mapOptions: {} };\n";
      $js .= "overview_options.mapOptions.maxExtent = map.maxExtent;\n";
      $js .= "overview_options.mapOptions.projection = map.projection;\n";
      $js .= "overview_options.mapOptions.units = map.units;\n";
      
      // If no layers are given, the base layer for the main map is used.
      // mapOptions can contain: maxExtent: new OpenLayers.Bounds(...), maxResolution, projection, units

      // TODO: add wms layers
      $js .= "wms.setIsBaseLayer(true);\n"; // the overview map needs a baselayer for determining the maxextent
      $js .= "overview_options.layers = [wms];\n";
      
      $js .= "var overview = new OpenLayers.Control.OverviewMap(overview_options);\n";
      $js .= "map.addControl(overview);\n";
    }
    if (in_array('overview', $controls)) {
      // default OverviewMap control
      $js .= "var overview = new OpenLayers.Control.OverviewMap();\n";
      $js .= "map.addControl(overview);\n";
    }
    
    // initial extent?
    if (isset($initial_extent)) {
      $js .= "  var initial_bounds = new OpenLayers.Bounds($initial_extent);\n";
    }
    
    // (5d) edits
    if (isset($map['edits'])) {
      $edits = explode('|', $map['edits']);
      foreach ($edits as $edit) {
        $edit_def = explode(':', $edit);
        
        // define edits layer
        $js .= "var edits_layer = new OpenLayers.Layer.Vector('_edits_', {displayInLayerSwitcher: false});\n";
        $js .= "map.addLayers([edits_layer]);\n";
        // drag control to move point
        $js .= "var edits_drag_control = new OpenLayers.Control.DragFeature(edits_layer);\n";
        $js .= "map.addControl(edits_drag_control);\n";
        $js .= "edits_drag_control.activate();\n";
        
        $js .= "\$(document).ready(function(){
          var el_x = document.getElementById('edit-x');
          var el_y = document.getElementById('edit-y');
          if (el_x && el_y) {
            if (el_x.value == '') {
              // set srid to (display)projection
              var proj = map.projection;
              if (map.displayProjection) {
                proj = map.displayProjection;
              }
              if (typeof(initial_bounds) != 'undefined') {
                var center = initial_bounds.getCenterLonLat();
              }
              else {
                var center = map.maxExtent.getCenterLonLat();
                if (map.displayProjection) {
                  center.transform(map.projection, map.displayProjection);
                }
              }
              var el_srid = document.getElementById('edit-srid');
              if (el_srid) {
                el_srid.value = proj.projCode.split(':')[1];
              }
              // set x to center of map
              el_x.value = center.lon;
              el_y.value = center.lat;
            }
            var geom = new OpenLayers.Geometry.Point(el_x.value, el_y.value);
            if (edits_layer.map.displayProjection) {
              geom.transform(edits_layer.map.displayProjection, edits_layer.map.projection);
            }
            edits_layer.addFeatures([new OpenLayers.Feature.Vector(geom)]);
            // set center of map to this location
            if (typeof(initial_bounds) == 'undefined') {
              if (!map.getCenter()) {
                map.setCenter(new OpenLayers.LonLat(geom.x, geom.y), Math.round(map.numZoomLevels/2));
              }
            }
            
            //alert(el_x.value + ' ' + el_y.value);
          }
        });\n";
        /*
        // point control to (re)locate point
        $js .= "var edits_point_control = new OpenLayers.Control.DrawFeature(edits_layer, OpenLayers.Handler.Point);\n";
        $js .= "map.addControl(edits_point_control);\n";
        $js .= "edits_point_control.activate();\n";
        */
        
        // todo: set first point to form field values
        //$js .= "edits_layer.addFeatures([new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Point(edits_layer.map.getCenter().lon, edits_layer.map.getCenter().lat))]);\n";
        
        $js .= "edits_drag_control.onDrag = function(feature, pixel){
        var el_x = document.getElementById('edit-x');
        var el_y = document.getElementById('edit-y');
        if (el_x && el_y) {
          var lonlat = feature.layer.map.getLonLatFromPixel(pixel);
          // todo: transform lonlat object?
          if (feature.layer.map.displayProjection) {
            lonlat.transform(feature.layer.map.projection, feature.layer.map.displayProjection);
          }
          el_x.value = lonlat.lon;
          el_y.value = lonlat.lat;
          //OpenLayers.Console.debug('feature', feature);
        }
        }\n";
        
        switch ($edit_def) {
        case 'point':
          // form fields in $edit_def[1]
          break;
        }
      }
    }
    
    // (6) zoom
    $js .= "if (!map.getCenter()) {\n";
    if (isset($map['zoom'])) {
      // zoom if center hasn't yet been set by permalink
      $js .= "  var center = new OpenLayers.LonLat({$center[0]}, {$center[1]});\n";
      $js .= "  if (map.displayProjection) { center.transform(map.displayProjection, map.getProjectionObject()); }\n";
      $js .= "  map.setCenter(center, $zoom);\n";
    }
    else if (isset($initial_extent)) {
      $js .= "  if (map.displayProjection) { initial_bounds.transform(map.displayProjection, map.getProjectionObject()); }\n";
      $js .= "  map.zoomToExtent(initial_bounds);\n";
    }
    else {
      // zoom to maxextent if center hasn't yet been set by permalink
      $js .= "  map.zoomToMaxExtent();\n";
    }
    $js .= "}\n";
    
    // (7) listeners, error handling
    $js .= "map.events.register('movestart', map, MappingKit.movestart);\n";
    $js .= "map.events.register('removelayer', map, MappingKit.removelayer);\n";
    
    // firebug
    $_SESSION['firebug'] && $js .= "OpenLayers.Console.debug('resolutions', map.resolutions);\n";

  }
  $js .= "}\n";
  $js .= "//-->\n";
  
  drupal_add_js($js, 'inline', 'footer');
  drupal_add_js("
    if (Drupal.jsEnabled) {
      // ready is ok in Firefox, but not in IE6
      //\$(document).ready(MappingKit.init);
      // alternative for ready, works in IE6 also
      if (window.addEventListener) {
        window.addEventListener('load', MappingKit.init, false);
      }
      else if (window.attachEvent) {
        window.attachEvent('onload', MappingKit.init);
      }
      else {
        window.onload = MappingKit.init;
      }
    }", 'inline', 'footer');
  // use onload if IE gives problems for VML
  //global $onload; $onload = "MappingKit.init()";
}

function js_ize($str) {
  return str_replace("'", "\\'", $str);
}

/**
 * @return javascript for baselayer options
 */
function get_baselayer_options_js($baselayer_options = NULL) {
  $js = "var layer_options = {};\n";
  if (!$baselayer_options) {
    return $js;
  }
  
  foreach($baselayer_options as $option => $value) {
    switch($option) {
      case 'opacity':
        $js .= "layer_options.opacity = $value;\n";
        break;
      case 'minzoomlevel':
        $js .= "layer_options.MIN_ZOOM_LEVEL = $value;\n";
        break;
      case 'numzoomlevels':
        $js .= "layer_options.numZoomLevels = $value;\n";
        break;
      default:
        $js .= "layer_options.$option = $value;\n";
        break;
    }
  }
  return $js;
}

/**
 * Explode options string into associative array of options.
 * @param $options_str
 *   String with option keys and values. Key=value pairs are separated by 
 *   comma's. Note that the value may contain '='-signs.
 *   Format example:
 *     key_a=value_a,key_b={key_c:value,key_d:value},key_c=x=1&y=2.
 * @return Associative array of options and their values.
 */
function mk_explode_options($options_str) {
  $options = array();
  $kv_regex = '/(\w+)\=(\{.*\}|[^,\{\}]*)/';
  $pv_regex = '/(\w+)\:([^,\}]*)/';
  $result = preg_match_all($kv_regex, $options_str, $matches);
  for ($i = 0; $i < $result; $i++) {
    $key = $matches[1][$i];
    $value = $matches[2][$i];
    // check if value contains property:value pairs
    if ($value[0] == '{' && ($pcount = preg_match_all($pv_regex, $value, $pmatches)) > 0) {
      $options[$key] = array_combine($pmatches[1], $pmatches[2]);
    }
    else {
      $options[$key] = $value;
    }
  }
  return $options;
}

/**
 *
 */
function mk_add_properties_js($obj, $key, $value = NULL) {
  $js = '';
  if (is_array($key)) {
    // key contains key/value pairs
    foreach ($key as $propname => $propvalue) {
      $js .= mk_add_properties_js($obj, $propname, $propvalue);
    }
  }
  else if (is_array($value)) {
    $js .= "if (!$obj.$key) $obj.$key = {};\n";
    $js .= mk_add_properties_js("$obj.$key", $value);
  }
  else if (!empty($value)) {
    if (is_numeric($value) || $value == 'true' || $value == 'false') {
      $js .= "$obj.$key = $value;\n";
    }
    else {
      $js .= "$obj.$key = '$value';\n";
    }
  }
  return $js;
}

function new_OpenLayers_Layer($layer) {
  switch ($layer[0]) {
  case 'image':
    return new OpenLayers_Image_Layer($layer);
  }
}

class OpenLayers_Layer {
  public $type;
  
  function __construct() {
  }
}

class OpenLayers_Image_Layer extends OpenLayers_Layer {
  function __construct() {
    parent::__construct();
    
    $this->type = 'image';
  }
}

/**
 * @param $layer
 *   Array of layer specification. Order: image|url|title|size.
 * @return
 *   Javascript code for wms layer
 */
function openlayers_finish_layer_image($layer, $js_map = 'map') {
  $js = '';
  
  // image|url|title|size
  $url = mapclient_get_url($layer[1]);
  
  $title = t('Image');
  if (!empty($layer[2])) {
    $title = $layer[2];
  }
  $title = js_ize($title); // check title for '
  
  $js .= "var image = new OpenLayers.Layer.Image('{$title}', '{$url}', map_options.maxExtent, new OpenLayers.Size({$layer[3]}), layer_options);\n";
  $js .= "{$js_map}.addLayer(image);\n";
  return $js;
}

function openlayers_finish_layer_gpx($layer) {
  // gpx|url|title|marker|options
  $js = '';
  
  return $js;
}

function openlayers_finish_layer_wms($layer, $js_map = 'map') {
  // wms|url|title|layer names|options
  $js = '';
  
  $title = js_ize(empty($layer[2]) ? 'WMS' : $layer[2]);
  
  $js .= "layer_options.opacity = 1.0;\n";
  $js .= "layer_options.displayInLegend = true;\n";
  if (!empty($layer[4])) {
    $extras = mk_explode_options($layer[4]);
    foreach ($extras as $key => $value) {
      switch ($key) {
      case 'legendurl':
        $js .= "layer_options.legend = {};\n";
        $js .= "layer_options.legend.href = '{$value}';\n";
        break;
      case 'info_format':
        $js .= "layer_options.info_formats = ['{$value}'];\n";
        break;
      default:
        $js .= mk_add_properties_js('layer_options', $key, $value);
        break;
      }
    }
  }
  
  $js .= "var wms_options = {layers: '{$layer[3]}', format: 'image/png', transparent: 'TRUE'};\n";
  // try to pass additional wms request options
  //$parts = parse_url($layer[1], PHP_URL_QUERY);
  //drupal_set_message(var_export($parts,true));
  
  if ($js_map == 'map') {
    $js .= "layer_options.isBaseLayer = !\$defined(map.baseLayer);\n";
  }
  $js .= "var wms = new OpenLayers.Layer.WMS('{$title}', '{$layer[1]}', wms_options, layer_options);\n";
  // gutter for demis world maps: 18
  //$js .= "wms.gutter = 0;\n";
  if (!empty($js_map)) {
    $js .= "{$js_map}.addLayer(wms);\n";
  }
  return $js;
}

